package com.iesvdc.acceso.simplecrud.controller;

import java.io.IOException;
import java.time.LocalDate;
import java.util.List;
import javax.servlet.ServletException;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.iesvdc.acceso.simplecrud.dao.ReservaDao;
import com.iesvdc.acceso.simplecrud.dao.UsuarioDao;
import com.iesvdc.acceso.simplecrud.daoimpl.ReservaDaoImpl;
import com.iesvdc.acceso.simplecrud.daoimpl.UsuarioDaoImpl;
import com.iesvdc.acceso.simplecrud.model.Usuario;

public class ReservaManagement extends HttpServlet {
    
    @Override 
    public void init() throws ServletException {
        
    }

    // findOne(id)
    @Override
    protected void doGet(
        HttpServletRequest req, // parámetros de la petición
        HttpServletResponse resp) // respuesta que genero
        throws IOException {
            Cookie loginCookie = null;
            Cookie[] cookies = req.getCookies();
            if (cookies != null) {
                for (Cookie cookie : cookies) {
                    if (cookie.getName().equals("ges_res.user")) {
                        loginCookie = cookie;
                        //buscamos su ID de la BBDD
                        UsuarioDao uDao = new UsuarioDaoImpl();
                        List<Usuario> u = uDao.findByUsername(loginCookie.getValue());
                        Integer usuarioId = u.get(0).getId();
                        String datos = "<h1>GET ReservaManagement: </h1>"+"usuarioId: "+usuarioId+"<br>";
                        resp.getWriter().println(datos);
                    }
                }
            } else {
                resp.getWriter().println("ERROR!!!");
            }
    }

    // CREAR
    @Override
    protected void doPost(
        HttpServletRequest req, // parámetros de la petición
        HttpServletResponse resp) // respuesta que genero
        throws ServletException, IOException {
            
            String fecha = req.getParameter("fecha");
            String horario = req.getParameter("horario");
            // recuperamos de la sesión el usuario
            Cookie loginCookie = null;
            Cookie[] cookies = req.getCookies();
            if (cookies != null) {
                for (Cookie cookie : cookies) {
                    if (cookie.getName().equals("ges_res.user")) {
                        loginCookie = cookie;
                         //buscamos su ID de la BBDD
                        UsuarioDao uDao = new UsuarioDaoImpl();
                        List<Usuario> u = uDao.findByUsername(loginCookie.getValue());
                        Integer usuarioId = u.get(0).getId();

                        ReservaDao rDao = new ReservaDaoImpl();
                        if (rDao.create(usuarioId, Long.parseLong(horario), LocalDate.parse(fecha))) {
                            resp.setStatus(200);
                        } else {
                            String datos = "<h1>ERROR al dar de alta: </h1>" +
                                "usuarioId: "+usuarioId+"<br>"+
                                "horarioId: "+horario+"<br>"+
                                "fecha: "+LocalDate.parse(fecha).toString()+"<br>";
                            resp.setStatus(500);    
                            resp.getWriter().println(datos);
                         }
                    }
                }
            }
    }

    // BORRAR
    @Override
    protected void doDelete(
        HttpServletRequest req, // parámetros de la petición
        HttpServletResponse resp) // respuesta que genero
        throws ServletException, IOException {

    }

    // ACTUALIZAR
    @Override
    protected void doPut(
        HttpServletRequest req, // parámetros de la petición
        HttpServletResponse resp) // respuesta que genero
        throws ServletException, IOException {

        
    }
}