<%@ taglib uri="http://java.sun.com/jsp/jstl/sql" prefix="sql" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8" %>

<sql:query var="installationList" dataSource="jdbc/gestionReservas">
    select id, nombre from instalacion;
</sql:query>


<%@ include file="../header.jsp" %>

    <div id="paso1" align="center">
        <div class="form" id="user-form">
            <caption><h2>Seleccione la instalación que desea reservar:</h2></caption>
            <input type="date" id="fechaReserva">
            <select id="installationIdSelect" onchange="mostrarHorarios()">
                <c:forEach var="installation" items="${installationList.rows}">
                    <option value="${installation.id}"/> 
                        <c:out value="${installation.nombre}" />
                    </option>
                </c:forEach>
            </select>
        </div>
    </div>

    <div id="paso2" align="center">
        Selección de horario
    </div>

<script type="text/javascript">
 
$("#paso2").hide();

$("#user-form > option").first().attr("selected", true);
// $("#user-form > option").first().prop("selected", true);

function mostrarHorarios(){
    // $("#paso1").hide();
    // pedimos al backend los horarios de una instalación dada
    let instalacionID = $("#installationIdSelect").val();
    let url = 'http://localhost:9090/rest/api/horario/instalacion/'+instalacionID;
    // 
    $.ajax({
            type : 'GET',
            url : url,
            contentType: 'application/json',
            // data : JSON.stringify({name: userName, email: userEmail}),
            success : function(data, status, xhr){
                // console.log(data);
                let horarios = data;
                var html = '<table class="table">';
                html += '<thead><tr><th>id horario</th><th>instalacion</th><th>inicio</th><th>fin</th><th>acción</th></tr></thead>';
                html += '<tbody>';   
                horarios.forEach( (horario) =>{
                    /*
                    let inicio = new Date();
                    inicio.setHours(horario.inicio.hour);
                    inicio.setMinutes(horario.inicio.minute);
                    inicio.setSeconds(0);

                    let fin = new Date();
                    fin.setHours(horario.fin.hour);
                    fin.setMinutes(horario.fin.minute);
                    fin.setSeconds(0);
                    */
                    html += '<tr>';
                    html += '<td>'+horario.id+'</td>';
                    html += '<td>'+horario.instalacion.name+'</td>';
                    html += '<td>'+horario.inicio+'</td>';
                    html += '<td>'+horario.fin+'</td>';
                    html += '<td>'+
                        '<button class="btn btn-success" onclick="formularioR('+horario.id+')"> reservar </button>' + 
                        '</td>';
                    html += '</tr>';
                });
                html += '</tbody>';
                html += '</table>';
                $('#paso2').html(html);
                $('#paso2').show();
            },
            error: function(xhr, status, error){
            $('#msg').html('<span style=\'color:red;\'>'+error+'</span>')
            }
        });

};

function setTimeOnInput(id, time) {
  $(id).attr({'value': time});
};


function formularioR(id){
    datos = "horario="+id+"&fecha="+$("#fechaReserva").val();
    
    $.ajax({
            url: '/reserva?'+datos ,
            method: 'POST',
            /*success: function() {
                window.location.replace('/privado/reservaRead.jsp');
            },*/
            error: function (xhr, status) {
                $('#msg').html('<span style=\'color:red;\'>'+error+'</span>');
            }
        }).done(
            () => {
                window.location.replace('/privado/reservaRead.jsp');
            }
        );
}
</script>


<%@ include file="../footer.jsp"%> 
