<%@ taglib uri="http://java.sun.com/jsp/jstl/sql" prefix="sql" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8" %>

<sql:query var="reservaList" dataSource="jdbc/gestionReservas">
    select r.id, i.nombre, h.inicio, h.fin, r.fecha, u.username
    from horario h, instalacion i, reserva r, usuario u
    where h.instalacion = i.id and r.horario = h.id and r.usuario = u.id
    order by r.fecha, i.nombre, h.inicio;
</sql:query>


<%@ include file="../header.jsp" %>
    <div align="center">
        <h2>Lista de reservas</h2>
        
        <table class="table" id="datos">
            <thead>
                <tr>
                    <th> # </th>
                    <th>usuario</th>
                    <th>instalacion</th>
                    <th>fecha</th>
                    <th>Hora inicio</th>
                    <th>Hora fin</th>

                </tr>
            </thead>
            <!-- r.id, i.nombre, h.inicio, h.fin, r.fecha, u.name -->
            <tbody>
                <c:forEach var="reserva" items="${reservaList.rows}">
                    <tr>
                        <td><c:out value="${reserva.id}"/></td>
                        <td><c:out value="${reserva.username}" /></td>
                        <td><c:out value="${reserva.nombre}" /></td>
                        <td><c:out value="${reserva.fecha}" /></td>
                        <td><c:out value="${reserva.inicio}" /></td>
                        <td><c:out value="${reserva.fin}" /></td>
                    </tr>
                </c:forEach>
            </tbody>
        </table>
    </div>

    <script>
        $("#buscadorHorario").on("input",function (){
            datos=$("#buscadorHorario").val();
            // oculta todo
            $("tr").hide();
            // muestra sólo la selección: un TR que contiene TD con estos datos
            $("tr:has(td:contains("+datos+"))").each(function(){
                console.log($(this));
                $(this).show();
            });
        });
    </script>
<%@ include file="../footer.jsp"%> 